<template>
  <div>
  <div v-show="!switchItems">
    <!--引用表格-->
   <BasicTable @register="registerTable" >
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template #htmlSlot="{text}">
         <div v-html="text"></div>
      </template>
      <!--省市区字段回显插槽-->
      <template #pcaSlot="{text}">
         {{ getAreaTextByCode(text) }}
      </template>
      <template #fileSlot="{text}">
         <span v-if="!text" style="font-size: 12px;font-style: italic;">无文件</span>
         <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)">下载</a-button>
      </template>
    </BasicTable>
    <!-- 表单区域 -->
  //  <StProjectExecModal @register="registerModal" @success="handleSuccess"></StProjectExecModal>
    </div>
  <StProjectContentExec v-show="switchItems" :complianeInfoRecord="complianeInfoRecord" @callBack="rbckHandler" ref="citemContentRef"></StProjectContentExec>
</div>
</template>

<script lang="ts" name="project.exec-stProjectExec" setup>
  import {ref, computed, unref} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import StProjectContentExec from './StProjectContentExec.vue';

 // import StProjectExecModal from './components/StProjectExecModal.vue'
  import {columns, searchFormSchema} from './StProjectExec.data';
  import {saveOrUpdate,list, deleteOne, batchDelete, getImportUrl,getExportUrl} from './StProjectExec.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  const switchItems = ref(false);
  const complianeInfoRecord = ref({});
  const citemContentRef = ref(null);
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, {openModal}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '项目实施',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 120,
               fixed:'right'
            },
      },
       exportConfig: {
            name:"项目实施",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload},{ rowSelection, selectedRowKeys }] = tableContext

   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  async function handleEdit(record: Recordable) {
     await saveOrUpdate({projectCreId: record.projectCreId,execLevel: record.execLevelCode}, handleSuccess);
   }
   /**
    * 详情
   */
  function openItem(data) {
    handleItem(data)
  }
  function handleDetail(record: Recordable) {
    switchItems.value = true;
    complianeInfoRecord.value = record;
    citemContentRef.value?.initActiveKey(record.projectCreId,record.execLevelCode);
  }
  function rbckHandler(data){
    switchItems.value = false;
    reload();
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
         {
           label: '提交',
           disabled: record['sumCount']!=record['overCount']&&record['execLevelCode']!='0000'||record['execLevelCode']=='0005',
           popConfirm: {
             title: '你是否确认提交已填报内容',
             confirm: handleEdit.bind(null, record),           
           }
         },
         {
           label: '查看',
           onClick: handleDetail.bind(null, record),
         }
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
       ]
   }


</script>

<style scoped>

</style>